include "console.iol"

inputPort TimerPort {
	Location: "local"
	OneWay: tick( string ), tock ( string )
}

type MyTimerType: long {
  .operation: string
  .message: undefined
}

outputPort MyTimer {
  OneWay: setNextTimeout( MyTimerType )
}

embedded {
  Java: "MyTimer" in MyTimer
}

execution{ concurrent }

init
{
    tickTimer = 1000;

    with( tickTimer ){
      .operation = "tick";
      .message = "--== Tick ==--"
    };

    tockTimer = 1000;
    with( tockTimer ){
      .operation = "tock";
      .message = "--== Tock ==--"
    };

    { setNextTimeout@MyTimer( tockTimer ) |
    setNextTimeout@MyTimer( tickTimer ) }
    
}

main
{
	[ tick( tickMsg ) ]{
    println@Console( tickMsg )();
    setNextTimeout@MyTimer( tickTimer )  
  }

  [ tock ( tockMsg ) ]{
		println@Console( tockMsg )();
		setNextTimeout@MyTimer( tockTimer )
  } 
}